/*------------------------------------------------------------------------------------------*\
 *   Copyright (C) 2011 AVM GmbH <fritzbox_info@avm.de>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
\*------------------------------------------------------------------------------------------*/

#ifndef LINUX_AVMNET_H
#define LINUX_AVMNET_H

#define AVMNET_VCC_QOS

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
enum avmnet_phy_power_mode {
    AVMNET_PHY_POWER_OFF = 0,
    AVMNET_PHY_POWER_SAVE = 1,
    AVMNET_PHY_POWER_ON = 2,
    AVMNET_PHY_POWER_NUMBER_OF_MODES = 3
};

enum avm_cpmac_magpie_reset
{
    CPMAC_MAGPIE_RESET_ON = 0,
    CPMAC_MAGPIE_RESET_OFF = 1,
    CPMAC_MAGPIE_RESET_PULSE = 2
};

/*------------------------------------------------------------------------------------------*\
 * Steuern der GPIOs die an den Phys angeschlossen sind
 *  0 -  7  eth0
 *  7 - 15  eth1
 * 16 - 23  eth2
 * 24 - 31  eth3
 * 32 - 39  eth4
 *  ....
\*------------------------------------------------------------------------------------------*/
void avmnet_gpio(unsigned int gpio, unsigned int on);

#endif /*--- #ifndef LINUX_AVMNET_H ---*/

